import React, { MouseEvent } from 'react';
import { InputElementType } from '@procyon/types/form';
import { Option } from '@procyon/types/options';
export type OptionViewProps = {
    icons?: {
        [key: string]: React.ReactNode;
    };
};
export type InnerOptionsProps = {
    onClick: ({ code, name }: Option, e: MouseEvent<HTMLDivElement>) => void;
    option: Option;
    value: string;
};
export type RadioButtonProps<V = Option> = Omit<{
    horizontal?: boolean;
    options: Option[];
    responsive?: boolean;
    view?: React.ReactElement<OptionViewProps>;
} & InputElementType<V>, 'onFocus' | 'onBlur' | 'onChange' | 'disabled'>;
export declare const RadioButton: React.FC<RadioButtonProps>;
