"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TimePickerModal = void 0;
const react_1 = __importStar(require("react"));
const date_fns_1 = require("date-fns");
const Button_1 = require("@procyon/components/Button");
const Grid_1 = require("@procyon/components/Grid");
const GridCol_1 = require("@procyon/components/GridCol");
const Trash_1 = __importDefault(require("@procyon/components/Icons/Trash"));
const hooks_1 = require("@procyon/components/Modal/hooks");
const enums_1 = require("@procyon/types/enums");
const TimeList_1 = __importDefault(require("./TimeList"));
const { base } = Grid_1.GridSizeEnum;
const TimePickerModal = (props) => {
    const { onChange, modalName, scrollToCode } = props;
    const { closeModal } = (0, hooks_1.useModal)();
    const [hour, setHour] = (0, react_1.useState)();
    const [minute, setMinute] = (0, react_1.useState)();
    (0, react_1.useEffect)(() => {
        if (props.value) {
            const value = (0, date_fns_1.format)(props.value, 'HH:mm');
            const hour = value.split(':')[0];
            const minute = value.split(':')[1];
            setHour(parseInt(hour));
            setMinute(parseInt(minute));
        }
    }, [props.value]);
    const handleSetHour = (value) => {
        setHour(value);
    };
    const handleSetMinute = (value) => {
        setMinute(value);
    };
    const handleChangeValue = () => {
        var _a;
        let value = (_a = props.value) !== null && _a !== void 0 ? _a : new Date();
        value = (0, date_fns_1.setHours)(value, hour !== null && hour !== void 0 ? hour : 0);
        value = (0, date_fns_1.setMinutes)(value, minute !== null && minute !== void 0 ? minute : 0);
        value = (0, date_fns_1.setSeconds)(value, 0);
        onChange(value);
        closeModal(modalName);
    };
    const handleClearValue = () => {
        setHour(null);
        setMinute(null);
        onChange(undefined);
        closeModal(modalName);
    };
    const selectedHour = hour ? hour : undefined;
    const selectedMinute = minute ? minute : undefined;
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(Grid_1.Grid, { cols: { [base]: 2 } },
            react_1.default.createElement(GridCol_1.GridCol, null,
                react_1.default.createElement(TimeList_1.default, Object.assign({ name: "hour", onChange: handleSetHour }, props.hour, { selectedCode: selectedHour, scrollToCode: scrollToCode }))),
            react_1.default.createElement(GridCol_1.GridCol, null,
                react_1.default.createElement(TimeList_1.default, Object.assign({ name: "minute", onChange: handleSetMinute }, props.minute, { selectedCode: selectedMinute, scrollToCode: scrollToCode })))),
        react_1.default.createElement(Grid_1.Grid, { cols: { [base]: 2 }, className: "mt-4" },
            react_1.default.createElement(GridCol_1.GridCol, null,
                react_1.default.createElement(Button_1.Button, { size: enums_1.SizeEnum.sm, label: "Pou\u017E\u00EDt", status: enums_1.StatusEnum.success, onClick: handleChangeValue })),
            react_1.default.createElement(GridCol_1.GridCol, null,
                react_1.default.createElement(Button_1.Button, { label: react_1.default.createElement(Trash_1.default, { fontSize: 20 }), size: enums_1.SizeEnum.sm, status: enums_1.StatusEnum.error, blank: true, onClick: handleClearValue })))));
};
exports.TimePickerModal = TimePickerModal;
